#include <qthing.h>
#include "event.h"

string_callback_t log_oled_handler = NULL;
void set_oled_log_handler(string_callback_t handler) {
    log_oled_handler = handler;
}
void log_oled(const std::string& message) {
    if (log_oled_handler != NULL) {
        log_oled_handler(message);
    }
}

connection_status_callback_t wlan_connection_status_handler = NULL;
void add_wlan_connection_status_handler(connection_status_callback_t handler) {
    if (wlan_connection_status_handler == NULL) {
        wlan_connection_status_handler = handler;
    }
    else {
        wlan_connection_status_handler = [wlan_connection_status_handler, handler](connection_status_t status){
            wlan_connection_status_handler(status);
            handler(status);
        };
    }
}
void update_wlan_connection_status(connection_status_t status) {
    if (wlan_connection_status_handler != NULL) {
        wlan_connection_status_handler(status);
    }
}

connection_status_callback_t mqtt_connection_status_handler = NULL;
void add_mqtt_connection_status_handler(connection_status_callback_t handler) {
    if (mqtt_connection_status_handler == NULL) {
        mqtt_connection_status_handler = handler;
    }
    else {
        mqtt_connection_status_handler = [mqtt_connection_status_handler, handler](connection_status_t status){
            mqtt_connection_status_handler(status);
            handler(status);
        };
    }
}
void update_mqtt_connection_status(connection_status_t status) {
    if (mqtt_connection_status_handler != NULL) {
        mqtt_connection_status_handler(status);
    }
}
